/**
  ******************************************************************************
  * @file    vk1640B_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    072-01-2019
  * @brief   This file contains all files for vk1640B_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "vk1640B_driver.h"

/* extern variables ----------------------------------------------------------*/
//extern uint8_t ic_key;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1640B_write_buf[16];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/

/*******************************************************************************
* Function Name  : VK1640B_delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640B_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}	
/*******************************************************************************
* Function Name  : VK1640B_delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640B_delay_nms(unsigned long int n)
{
	while(n--)
	{
		VK1640B_delay_nus(1000);
	}
}

/*******************************************************************************
* Function Name  : VK1640B_Start
* Description    : VK1640Bʼź
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640B_Start(void)
{
	VK1640B_DAT_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1640B_SLK_HIGH;
	VK1640B_delay_nus(2);
	VK1640B_DAT_LOW;
	VK1640B_SLK_LOW;
	VK1640B_delay_nus(1);
}
/*******************************************************************************
* Function Name  : VK1640B_Stop
* Description    : VK1640Bֹͣź
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640B_Stop(void)
{
	VK1640B_SLK_LOW;
	VK1640B_delay_nus(1);
	VK1640B_DAT_LOW;
	VK1640B_SLK_HIGH;
	VK1640B_delay_nus(2);
	VK1640B_DAT_HIGH;
	VK1640B_delay_nus(1);
}
/*******************************************************************************
* Function Name  : VK1640BWrite1BytetoIC
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640BWrite1BytetoIC(unsigned char data8)
{
	unsigned char i;
	
	for(i=0;i<8;i++)
	{
		VK1640B_SLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1640B_DAT_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1640B_DAT_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1640B_delay_nus(2);
		VK1640B_SLK_HIGH;	//ʱӵ
		VK1640B_delay_nus(2);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640B_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ	
	
	VK1640B_Start();
	VK1640BWrite1BytetoIC(VK1640B_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK1640B_Stop();
	VK1640B_Start();	
	VK1640BWrite1BytetoIC(VK1640B_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1640BWrite1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK1640B_Stop();
	VK1640B_Start();	
	VK1640BWrite1BytetoIC(VK1640B_DISP_ON|VK1640B_PDUTY_10_16);//ʾ 10/16
	VK1640B_Stop();
}

/*******************************************************************************
* Function Name  : VK1640B_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640B_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1640B_Start();
	VK1640BWrite1BytetoIC(VK1640B_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
	VK1640B_Stop();
	VK1640B_Start();	
	VK1640BWrite1BytetoIC(VK1640B_STARTADDR+addr);//ʾݶӦĵַ
	VK1640BWrite1BytetoIC(data8);//1BYTEʾ
	VK1640B_Stop();
	VK1640B_Start();	
	VK1640BWrite1BytetoIC(VK1640B_DISP_ON|VK1640B_PDUTY_10_16);//ʾ 10/16
	VK1640B_Stop();
}
	
/*******************************************************************************
* Function Name  : Vk1640B_Init
* Description    : 1640Bʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1640B_Init(void)    
{   
	GPIO_SetMode(VK1640B_CLK_PORT, VK1640B_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1640B_DIO_PORT, VK1640B_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK1640B_DAT_HIGH;                
	VK1640B_SLK_HIGH; 
}  

/*******************************************************************************
* Function Name  : VK1640B_Main
* Description    : 1640BԳ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1640B_Main(void)
{   
	unsigned char i,j;
	
	VK1640B_Init();
	 
	for(i=0;i<12;i++)
	{
		vk1640B_write_buf[i]=0x00;
	}
	VK1640B_Disp_AutoAdd1Addr(0,vk1640B_write_buf,16);   //12ȫ
	VK1640B_delay_nms(1000); 
	while(1)
	{
		for(i=0;i<12;i++)
		{
			vk1640B_write_buf[i]=0xff;
		}
		VK1640B_Disp_AutoAdd1Addr(0,vk1640B_write_buf,16);   //12ȫ
		VK1640B_delay_nms(1000); 
		for(i=0;i<12;i++)
		{
			vk1640B_write_buf[i]=0x00;
		}
		VK1640B_Disp_AutoAdd1Addr(0,vk1640B_write_buf,12);   //ȫ
		VK1640B_delay_nms(1000); 
		
		for(j=0;j<12;j++)
		{
			for(i=0;i<12;i++)
			{
				vk1640B_write_buf[i]=0x00;
			}
			vk1640B_write_buf[j]=0xff;
			VK1640B_Disp_AutoAdd1Addr(0,vk1640B_write_buf,12);   
			VK1640B_delay_nms(500); 
		}
		for(j=0;j<8;j++)
		{
			for(i=0;i<12;i++)
			{
				vk1640B_write_buf[i]=(1<<j);
			}
			VK1640B_Disp_AutoAdd1Addr(0,vk1640B_write_buf,12);   
			VK1640B_delay_nms(1000); 
		}
		
		__nop();
	}
}    
/************************END OF FILE****/
